package com.vserrano.photos_share;

import android.accounts.AccountManager;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.googleapis.extensions.android.gms.auth.GoogleAccountCredential;
import com.google.api.client.json.gson.GsonFactory;
import com.google.api.services.drive.Drive;
import com.google.api.services.drive.DriveScopes;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.Locale;

import static com.vserrano.photos_share.UtilidadesDrive.*;

public class ActividadPrincipal extends AppCompatActivity {
    Button nuevafoto;
    Button acercade;
    Button miperfil;
    Button galeria;
    ImageView anillos;
    static final String idCarpeta="0B1Xp-Yu6-i7WYkRiZTByVHV6VVk";
    static final int SOLICITUD_SELECCION_CUENTA = 1;
    private TextView txtNombreCuenta;
    static final int SOLICITUD_AUTORIZACION = 2;
    OpcionesBD OpBD;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.content_actividad_principal);
        //Inicializar BD
        OpBD= new OpcionesBD(this);

        //Validar cuenta google drive
        if (comprobarGooglePlayServices()) {
            //mostrarMensaje(this,"Se ha encontrado Google Play Services válido.");
        } else {
            mostrarMensaje(this,"Error Google Play Services: no está instalado, actualizado o no es válido.");
            mostrarMensaje(this,"Instale o actualice Servicios de Google Play");
            //Abre la ruta al PlayStore para instalarlo o actualizarlo
            String url = "https://play.google.com/store/apps/details?id=com.google.android.gms&hl=es";
            Intent i = new Intent(Intent.ACTION_VIEW);
            i.setData(Uri.parse(url));
            startActivity(i);
            finish();
        }
        credencial =
                GoogleAccountCredential.usingOAuth2(ActividadPrincipal.this,
                        Arrays.asList(DriveScopes.DRIVE));
        txtNombreCuenta = (TextView) findViewById(R.id.ncuenta);
        SharedPreferences prefs = getSharedPreferences("Preferencias",
                Context.MODE_PRIVATE);
        nombreCuenta = prefs.getString("nombreCuenta", null);
        if (nombreCuenta != null) {
            credencial.setSelectedAccountName(nombreCuenta);
            servicio = obtenerServicioDrive(credencial);
            String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss",
                    Locale.ENGLISH).format(new Date());
            txtNombreCuenta.setText(timeStamp+" / " + nombreCuenta);
            //Sino existe, creamos nuevo usuario
            int buscaruser=OpBD.BuscarUsuario(nombreCuenta);
            if(buscaruser==-1) {
                OpBD.NuevoUsuario(nombreCuenta);
            }
        }else{
            PedirCredenciales();
        }
        //********************************************
        Typeface Advertising=Typeface.createFromAsset(getAssets(),"fonts/Advertising.ttf");
        galeria=(Button)findViewById(R.id.galeria);
        galeria.setTypeface(Advertising);
        galeria.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LanzarGaleria(v);
            }
        });
        anillos=(ImageView)findViewById(R.id.anillos);
        anillos.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LanzarBD(v);
            }
        });
        acercade=(Button)findViewById(R.id.acercade);
        acercade.setTypeface(Advertising);
        acercade.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                lanzarAcercaDe(view);
            }
        });
        nuevafoto=(Button)findViewById(R.id.nuevafoto);
        nuevafoto.setTypeface(Advertising);
        nuevafoto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LanzarNuevaFoto(v);
            }
        });
        miperfil=(Button)findViewById(R.id.miperfil);
        miperfil.setTypeface(Advertising);
        miperfil.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LanzarMiPerfil(v);
            }
        });
    }
    //***************************************************
    // Google drive
    private boolean comprobarGooglePlayServices() {
        int resultCode = GooglePlayServicesUtil.isGooglePlayServicesAvailable(this);
        if (resultCode != ConnectionResult.SUCCESS) {
            if (GooglePlayServicesUtil.isUserRecoverableError(resultCode)) {
                GooglePlayServicesUtil.getErrorDialog(resultCode, this,
                        PLAY_SERVICES_RESOLUTION_REQUEST).show();
            } else {
                finish();
            }
            return false;
        }
        return true;
    }
    private Drive obtenerServicioDrive(GoogleAccountCredential credencial) {
        return new Drive.Builder(AndroidHttp.newCompatibleTransport(),
                new GsonFactory(), credencial).build();
    }

    private void PedirCredenciales() {
        if (nombreCuenta == null) {
            startActivityForResult(credencial.newChooseAccountIntent(),
                    SOLICITUD_SELECCION_CUENTA);
        }
    }

    //***************************************************
    //Acercade
    public void lanzarAcercaDe(View view) {
        Intent i = new Intent(ActividadPrincipal.this, AcercaDe.class);
        startActivity(i);
    }
    //Galeria
    public void LanzarGaleria(View view) {
        Intent i = new Intent(ActividadPrincipal.this, Galeria.class);
        startActivity(i);
    }
    //Nueva Foto
    public void LanzarNuevaFoto(View view) {
        Intent i = new Intent(ActividadPrincipal.this, Nueva_photo.class);
        startActivity(i);
    }
    //Mi Perfil
    public void LanzarMiPerfil(View view) {
        Intent i = new Intent(ActividadPrincipal.this, MiPerfil.class);
        startActivity(i);
    }
    //Lanzar base de datos
    public void LanzarBD(View view) {
        Intent i = new Intent(ActividadPrincipal.this, AndroidDatabaseManager.class);
        startActivity(i);
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onActivityResult(final int requestCode,
                                    final int resultCode, final Intent data) {
        switch (requestCode) {
            case SOLICITUD_SELECCION_CUENTA:
                if (resultCode == RESULT_OK && data != null
                        && data.getExtras() != null) {
                    nombreCuenta = data
                            .getStringExtra(AccountManager.KEY_ACCOUNT_NAME);
                    if (nombreCuenta != null) {
                        credencial.setSelectedAccountName(nombreCuenta);
                        servicio = obtenerServicioDrive(credencial);
                        SharedPreferences prefs = getSharedPreferences(
                                "Preferencias", Context.MODE_PRIVATE);
                        SharedPreferences.Editor editor = prefs.edit();
                        editor.putString("nombreCuenta", nombreCuenta);
                        editor.commit();
                        txtNombreCuenta.setText(nombreCuenta);
                        //Sino existe, creamos nuevo usuario
                        int buscaruser=OpBD.BuscarUsuario(nombreCuenta);
                        if(buscaruser==-1) {
                            OpBD.NuevoUsuario(nombreCuenta);
                        }
                    } else {
                        txtNombreCuenta
                                .setText("[Elige una cuenta de Google Drive]");
                    }
                }
                break;

            case SOLICITUD_AUTORIZACION:
                if (resultCode == Activity.RESULT_OK) {
                } else {
                    mostrarMensaje(this,"El usuario no autoriza usar Google Drive");
                }
                break;
        }
    }
}
