package com.vserrano.photos_share;

import android.content.Context;
import android.database.Cursor;
import android.database.MatrixCursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import java.util.ArrayList;


public class BaseDatos extends SQLiteOpenHelper {

    //Version de la base de datos
    private static final int DATABASE_VERSION = 1;

    // Nombre Base de datos
    private static final String DATABASE_NAME = "PhotosShareBD.db";

    public BaseDatos(Context context ) {
        super(context, DATABASE_NAME, null, DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase bd) {

        //Crear base de datos
        bd.execSQL("CREATE TABLE Usuarios (_id INTEGER PRIMARY KEY AUTOINCREMENT,"+
                        "usuario TEXT, " +
                        "contra TEXT, " +
                        "foto TEXT, " +
                        "alias TEXT, " +
                        "calidad_imagen INTEGER, " +
                        "falta LONG, " +
                        "fbaja LONG) ");

        bd.execSQL("CREATE TABLE Imagenes (_id INTEGER PRIMARY KEY AUTOINCREMENT, " +
                "imgoriginal TEXT,"+
                "imgmini TEXT, " +
                "filename TEXT, " +
                "comentario TEXT, " +
                "sinc_php INTEGER, " +
                "falta LONG, " +
                "fsincronizar LONG, " +
                "fbaja LONG) ");

    }

    @Override
    public void onUpgrade(SQLiteDatabase bd, int oldVersion, int newVersion) {
        // Eliminar todas las tablas de la base de datos
        bd.execSQL("DROP TABLE IF EXISTS " + "Usuarios");
        bd.execSQL("DROP TABLE IF EXISTS " + "Imagenes");
        // Crear tablas nuevamente
        onCreate(bd);

    }

    //************************************************
    //Ver base de datos

    public ArrayList<Cursor> getData(String Query){
        //get writable database
        SQLiteDatabase sqlDB = this.getWritableDatabase();
        String[] columns = new String[] { "mesage" };
        //an array list of cursor to save two cursors one has results from the query
        //other cursor stores error message if any errors are triggered
        ArrayList<Cursor> alc = new ArrayList<Cursor>(2);
        MatrixCursor Cursor2= new MatrixCursor(columns);
        alc.add(null);
        alc.add(null);


        try{
            String maxQuery = Query ;
            //execute the query results will be save in Cursor c
            Cursor c = sqlDB.rawQuery(maxQuery, null);


            //add value to cursor2
            Cursor2.addRow(new Object[] { "Success" });

            alc.set(1,Cursor2);
            if (null != c && c.getCount() > 0) {


                alc.set(0,c);
                c.moveToFirst();

                return alc ;
            }
            return alc;
        } catch(SQLException sqlEx){
            Log.d("printing exception", sqlEx.getMessage());
            //if any exceptions are triggered save the error message to cursor an return the arraylist
            Cursor2.addRow(new Object[] { ""+sqlEx.getMessage() });
            alc.set(1,Cursor2);
            return alc;
        } catch(Exception ex){

            Log.d("printing exception", ex.getMessage());

            //if any exceptions are triggered save the error message to cursor an return the arraylist
            Cursor2.addRow(new Object[] { ""+ex.getMessage() });
            alc.set(1,Cursor2);
            return alc;
        }


    }
    //**********************************************

}
