package com.vserrano.photos_share;


import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Typeface;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.NavigationView;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.StaggeredGridLayoutManager;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.googleapis.extensions.android.gms.auth.GoogleAccountCredential;
import com.google.api.client.googleapis.extensions.android.gms.auth.UserRecoverableAuthIOException;
import com.google.api.client.json.gson.GsonFactory;
import com.google.api.services.drive.Drive;
import com.google.api.services.drive.DriveScopes;
import com.google.api.services.drive.model.ChildList;
import com.google.api.services.drive.model.ChildReference;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicHeader;
import org.apache.http.protocol.HTTP;
import org.json.JSONObject;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import static com.vserrano.photos_share.UtilidadesDrive.*;
import static com.vserrano.photos_share.ActividadPrincipal.*;

public class Galeria extends AppCompatActivity implements NavigationView.OnNavigationItemSelectedListener {

    OpcionesBD OpBD;
    RecyclerView recyclerView;
    private ProgressDialog pDialog;
    TextView nombre_perfil;
    TextView cuenta_perfil;
    static com.github.siyamed.shapeimageview.CircularImageView foto_perfil=null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_galeria);
        recyclerView = (RecyclerView) findViewById(R.id.recyclerView);
        Typeface Advertising=Typeface.createFromAsset(getAssets(),"fonts/Advertising.ttf");
        //*********************************
        if (comprobarGooglePlayServices()) {
            //mostrarMensaje(this,"Se ha encontrado Google Play Services válido.");
        } else {
            mostrarMensaje(this,"Error Google Play Services: no está instalado o no es válido.");
            finish();
        }
        credencial =
                GoogleAccountCredential.usingOAuth2(Galeria.this,Arrays.asList(DriveScopes.DRIVE));
        SharedPreferences prefs = getSharedPreferences("Preferencias",
                Context.MODE_PRIVATE);
        nombreCuenta = prefs.getString("nombreCuenta", null);
        if (nombreCuenta != null) {
            credencial.setSelectedAccountName(nombreCuenta);
            servicio = obtenerServicioDrive(credencial);
        }
        //*********************************
        Toolbar toolbar = (Toolbar)findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        TextView titulopersonalizado = (TextView) toolbar.findViewById(R.id.toolbar_title);
        titulopersonalizado.setTypeface(Advertising);
        //Navigation drawer
        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        ActionBarDrawerToggle toggle = new ActionBarDrawerToggle(
                this, drawer, toolbar, R.string.navigation_drawer_open, R.string.navigation_drawer_close);
        drawer.setDrawerListener(toggle);
        toggle.syncState();

        NavigationView navigationView = (NavigationView) findViewById(R.id.nav_view);
        navigationView.setNavigationItemSelectedListener(this);
        //Si existe poner foto de perfil
        //app:headerLayout="@layout/nav_header_galeria"
        View hView =  navigationView.inflateHeaderView(R.layout.nav_header_galeria);
        foto_perfil = (com.github.siyamed.shapeimageview.CircularImageView)hView.findViewById(R.id.foto_perfil);
        nombre_perfil = (TextView)hView.findViewById(R.id.nombre_perfil);
        nombre_perfil.setText(OpBD.BuscarAlias(prefs.getString("nombreCuenta", null)));
        cuenta_perfil = (TextView)hView.findViewById(R.id.cuenta_perfil);
        cuenta_perfil.setText(prefs.getString("nombreCuenta", null));
        String rutaimg=OpBD.BuscarRutaFotoPerfil(prefs.getString("nombreCuenta", null));
        if(rutaimg.length()>1) {

            java.io.File imgFile = new java.io.File(rutaimg);

            if (imgFile.exists()) {

                Bitmap myBitmap = BitmapFactory.decodeFile(imgFile.getAbsolutePath());
                foto_perfil.setImageBitmap(myBitmap);

            }
        }
        //**********************************
        //cargarimagenesdrive();
        new CompararDriveBD().execute();

        FloatingActionButton fab=(FloatingActionButton)findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Actualizar manualmente galeria
                listarFicheros(v);
            }
        });
    }

    @Override
    public void onBackPressed() {
        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        if (drawer.isDrawerOpen(GravityCompat.START)) {
            drawer.closeDrawer(GravityCompat.START);
        } else {
            super.onBackPressed();
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);
        if(requestCode==2)
        {
            cargarimagenesdrive();
        }
    }

    protected void cargarimagenesdrive() {
        recyclerView.setHasFixedSize(true);
        recyclerView.setAdapter(new MyRecyclerAdapter(Galeria.this, OpBD.MostrarImagenesDrive(), R.layout.galeria_detalle));
        recyclerView.setLayoutManager(new StaggeredGridLayoutManager(2, StaggeredGridLayoutManager.VERTICAL));
        recyclerView.setItemAnimator(new DefaultItemAnimator());
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        setIntent(intent);
    }

    public void listarFicheros(View v) {
        if (nombreCuenta == null) {
            mostrarMensaje(this, "Debes seleccionar una cuenta de Google Drive");
        } else {
            new ActualizarG().execute(); //Actualizar con Asynctask en vez de con thread
        }
    }
    //drive
    private boolean comprobarGooglePlayServices() {
        int resultCode = GooglePlayServicesUtil.isGooglePlayServicesAvailable(this);
        if (resultCode != ConnectionResult.SUCCESS) {
            if (GooglePlayServicesUtil.isUserRecoverableError(resultCode)) {
                GooglePlayServicesUtil.getErrorDialog(resultCode, this,
                        PLAY_SERVICES_RESOLUTION_REQUEST).show();
            } else {
                finish();
            }
            return false;
        }
        return true;
    }

    private Drive obtenerServicioDrive(GoogleAccountCredential credencial) {
        return new Drive.Builder(AndroidHttp.newCompatibleTransport(),
                new GsonFactory(), credencial).build();
    }
    //Navigator Drawer
    @SuppressWarnings("StatementWithEmptyBody")
    @Override
    public boolean onNavigationItemSelected(MenuItem item) {
        // Handle navigation view item clicks here.
        int id = item.getItemId();

        if (id == R.id.nav_nfoto) {
            LanzarNuevaFoto();
        } else if (id == R.id.nav_galeria) {

        } else if (id == R.id.nav_miperfil) {
            LanzarMiPerfil();
        } else if (id == R.id.nav_acercade) {
            lanzarAcercaDe();
        }else if (id == R.id.nav_miweb) {
            String url = "http://victorserranobargues.esy.es/";
            Intent i = new Intent(Intent.ACTION_VIEW);
            i.setData(Uri.parse(url));
            startActivity(i);
        }

        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        drawer.closeDrawer(GravityCompat.START);
        return true;
    }

    //***********************
    //Acercade
    public void lanzarAcercaDe() {
        Intent i = new Intent(Galeria.this, AcercaDe.class);
        startActivity(i);
    }
    //Nueva Foto
    public void LanzarNuevaFoto() {
        Intent i = new Intent(Galeria.this, Nueva_photo.class);
        startActivity(i);
    }
    //Mi Perfil
    public void LanzarMiPerfil() {
        Intent i = new Intent(Galeria.this, MiPerfil.class);
        startActivity(i);
    }

    private class ActualizarG extends AsyncTask<Integer, Integer, Integer> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = new ProgressDialog(Galeria.this);
            pDialog.setIndeterminate(false);//establece el indicador de progreso a medida determinado o indeterminado
            pDialog.setMax(100); //calculado en base 100%
            pDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
            pDialog.setCancelable(false); //bloqueado
            pDialog.setMessage("Actualizando galería...");
            pDialog.show();
        }
        protected Integer doInBackground(Integer... args) {
            Integer contador=1;
            try {

                Drive.Children.List respuesta = servicio.children().list(
                        idCarpeta);
                //Lista con el maximo elementos 1000
                ChildList ficheros = respuesta.setMaxResults(1000).execute();
                // calcular tamaño para progressdialog
                List<ChildReference> result = new ArrayList<>();
                result.addAll(ficheros.getItems());
                Log.e("Total fotos drive: ", String.valueOf(result.size()));

                int numtotal=result.size();
                int contarimagenes=numtotal;
                //********************
                //Poner a 0 todos para mostrar solo los que esten en alta
                OpBD.ResetearThumbnailLink();
                for (ChildReference f : ficheros.getItems()) {
                    String idtemp=f.getChildLink();
                    publishProgress((int) ((contador /(float) numtotal) * 100));

                    String Filename;
                    String ThumbnailLink;
                    String IdFile;
                    Filename="-";
                    ThumbnailLink= String.valueOf(contarimagenes);
                    IdFile=idtemp.replace("https://www.googleapis.com/drive/v2/files/","");
                    // Elimina espacios delante y detras con trim
                    OpBD.ActualizarListaFotos(Filename,ThumbnailLink,IdFile.trim());
                    contador++;
                    contarimagenes--;
                }

            } catch (UserRecoverableAuthIOException e) {
                pDialog.dismiss();
                startActivityForResult(e.getIntent(),SOLICITUD_AUTORIZACION);
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return contador;
        }
        @Override
        protected void onProgressUpdate(Integer... porcentajeProgreso) {
            Log.e("Valores BD: ", String.valueOf(porcentajeProgreso[0]));
            pDialog.setProgress(porcentajeProgreso[0]);
        }
        @Override
        protected void onCancelled (Integer cantidadProcesados) {

        }
        @Override
        protected void onPostExecute(Integer resultado) {
            //Comparar resultado con contador para saber si ha realizado bien o no.
            pDialog.dismiss();
            mostrarMensaje(Galeria.this,"¡Galería Actualizada!");
            new SincronizarTodos().execute();
            //cargarimagenesdrive();

        }
    }

    private class CompararDriveBD extends AsyncTask<Integer, Integer, Integer> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = new ProgressDialog(Galeria.this);
            pDialog.setIndeterminate(false);//establece el indicador de progreso a medida determinado o indeterminado
            pDialog.setMax(100); //calculado en base 100%
            pDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
            pDialog.setCancelable(false); //bloqueado
            pDialog.setMessage("Actualizando galería...");
            pDialog.show();
        }

        protected Integer doInBackground(Integer... args) {
            Integer contador = 1;
            try {

                Drive.Children.List respuesta = servicio.children().list(
                        idCarpeta);
                //Lista con el maximo elementos 1000
                ChildList ficheros = respuesta.setMaxResults(1000).execute();
                // calcular tamaño para progressdialog
                List<ChildReference> result = new ArrayList<>();
                result.addAll(ficheros.getItems());
                Log.e("Total fotos drive: ", String.valueOf(result.size()));

                int numtotal = result.size();
                int contarimagenes=numtotal;
                int totalBD = OpBD.ContarElementos();
                if (numtotal != totalBD) {
                    //Poner a 0 todos para mostrar solo los que esten en alta
                    OpBD.ResetearThumbnailLink();
                    for (ChildReference f : ficheros.getItems()) {
                        String idtemp = f.getChildLink();
                        publishProgress((int) ((contador / (float) numtotal) * 100));
                        String Filename;
                        String ThumbnailLink;
                        String IdFile;
                        Filename = "-";
                        //Del ultimo al primero para saber cuantas imagenes tenemos
                        ThumbnailLink= String.valueOf(contarimagenes);
                        IdFile = idtemp.replace("https://www.googleapis.com/drive/v2/files/", "");
                        // Elimina espacios delante y detras con trim
                        OpBD.ActualizarListaFotos(Filename, ThumbnailLink, IdFile.trim());
                        contador++;
                        contarimagenes--;
                    }
                    return contador;
                }else{
                    return 0;
                }
            } catch (UserRecoverableAuthIOException e) {
                pDialog.dismiss();
                startActivityForResult(e.getIntent(), SOLICITUD_AUTORIZACION);
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return null;

        }

        @Override
        protected void onProgressUpdate(Integer... porcentajeProgreso) {
            Log.e("Valores BD: ", String.valueOf(porcentajeProgreso[0]));
            pDialog.setProgress(porcentajeProgreso[0]);
        }
        @Override
        protected void onCancelled (Integer cantidadProcesados) {

        }
        @Override
        protected void onPostExecute(Integer resultado) {
            //Comparar resultado con contador para saber si ha realizado bien o no.
            pDialog.dismiss();
            if (resultado!=null) {
                if (resultado == 0) {
                    mostrarMensaje(Galeria.this, "¡No se encontraron imagenes nuevas!");
                    cargarimagenesdrive();
                } else {
                    mostrarMensaje(Galeria.this, "¡Galería Actualizada!");
                    new SincronizarTodos().execute();
                }
            }else{
                mostrarMensaje(Galeria.this, "¡Galería Actualizada!");
                new SincronizarTodos().execute();
            }
        }
    }
    // Comentarios sincronizar con PHP mediante Json
    private String convertStreamToString(InputStream is) {

        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
        StringBuilder sb = new StringBuilder();

        String line = null;
        try {
            while ((line = reader.readLine()) != null) {
                sb.append(line + "\n");
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                is.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return sb.toString();
    }
    //Código del Web Service
    public class SincronizarTodos extends AsyncTask<Integer, Integer, Integer> {
        ProgressDialog dialog;
        protected void onPreExecute() {
            dialog = ProgressDialog.show(Galeria.this, "Cargando...", "Actualizando Página Web ");
        }
        protected Integer doInBackground(Integer...args0) {
            //************************
            try {
                HttpClient client = new DefaultHttpClient();
                org.apache.http.HttpResponse response;
                HttpPost post = new HttpPost("http://victorserranobargues.esy.es/Upv/views/galeria.php");
                JSONObject jsonObj=OpBD.SincronizarGaleriaPHP();

                Log.e("Json ", jsonObj.toString());
                StringEntity se = new StringEntity(jsonObj.toString());
                se.setContentEncoding(new BasicHeader(HTTP.CONTENT_TYPE, "application/json"));
                post.setEntity(se);

                response = client.execute(post);
                if (response != null) {
                    InputStream in = response.getEntity().getContent();

                    String a = convertStreamToString(in);
                    Log.e("Retorno del PHP", a);
                    String input = a.replace(" ","");
                    input = input.trim();
                    if(input.equals("OK")){
                        //Ha sincronizado todos los marco como sincronizados
                        OpBD.MarcarImagenesPHP();
                        return 1;//devuelvo ok
                    }else{
                        return 2; //PHP devuelve respuesta pero incorrecta
                    }

                }else{
                    return 3; //No devuelve respuesta el PHP
                }
            } catch (Exception e) {
                Log.d("error", e.toString());
            }
            return 2;
        }

        protected void onPostExecute(Integer valor) {
            dialog.dismiss();

            if (valor==1) {
                mostrarMensaje(Galeria.this, "¡Web actualizada!");

            }else{
                mostrarMensaje(Galeria.this, "¡Error al actualizar la web! "+valor);
            }
            cargarimagenesdrive();
        }
    }
}//Fin Galeria