package com.vserrano.photos_share;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.Typeface;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.googleapis.extensions.android.gms.auth.GoogleAccountCredential;
import com.google.api.client.json.gson.GsonFactory;
import com.google.api.services.drive.Drive;
import com.google.api.services.drive.DriveScopes;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.Locale;

import static com.vserrano.photos_share.UtilidadesDrive.PLAY_SERVICES_RESOLUTION_REQUEST;
import static com.vserrano.photos_share.UtilidadesDrive.credencial;
import static com.vserrano.photos_share.UtilidadesDrive.mostrarMensaje;
import static com.vserrano.photos_share.UtilidadesDrive.nombreCuenta;
import static com.vserrano.photos_share.UtilidadesDrive.servicio;


public class ImagenGaleria extends AppCompatActivity {
    private Bitmap bitmap = null;
    private ProgressDialog pDialog;
    private static String tag = "PhotosShare";
    static com.github.siyamed.shapeimageview.RoundedImageView photo = null;
    private String Idfichero;
    private String Filename;
    OpcionesBD OpBD;
    static InputStream input = null;
    static HttpURLConnection connection = null;
    static File folder;
    private TextView comentario_foto;
    private String comentario_php = "";
    static JSONObject json = null;
    static JSONParser jParser = null;
    static JSONArray user = null;
    static JSONObject c = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.imagen_galeria);
        //*********************************
        Toolbar t_imagengaleria = (Toolbar) findViewById(R.id.t_imagengaleria);
        setSupportActionBar(t_imagengaleria);
        TextView titulopersonalizado = (TextView) t_imagengaleria.findViewById(R.id.toolbar_title);
        Typeface Advertising = Typeface.createFromAsset(getAssets(), "fonts/Advertising.ttf");
        titulopersonalizado.setTypeface(Advertising);
        //*********************************
        TextView titulo = (TextView) findViewById(R.id.textView1);
        titulo.setTypeface(Advertising);

        comentario_foto = (TextView) findViewById(R.id.comentario_foto);
        comentario_foto.setText("");
        //Drive service
        if (comprobarGooglePlayServices()) {
            //mostrarMensaje(this,"Se ha encontrado Google Play Services válido.");
        } else {
            mostrarMensaje(this, "Error Google Play Services: no está instalado o no es válido.");
            finish();
        }
        credencial =
                GoogleAccountCredential.usingOAuth2(ImagenGaleria.this, Arrays.asList(DriveScopes.DRIVE));
        SharedPreferences prefs = getSharedPreferences("Preferencias",
                Context.MODE_PRIVATE);
        nombreCuenta = prefs.getString("nombreCuenta", null);
        if (nombreCuenta != null) {
            credencial.setSelectedAccountName(nombreCuenta);
            servicio = obtenerServicioDrive(credencial);
        }
        //*********************************
        photo = (com.github.siyamed.shapeimageview.RoundedImageView) findViewById(R.id.imageView);

        Intent intent = getIntent();
        Idfichero = intent.getStringExtra("Idfichero");
        //Obtener nombre, si no existe lo busco mediante servicios drive.
        if (Idfichero.length() > 1) {
            Filename = OpBD.BuscarFilename(Idfichero);
        }
        Log.e("Filename BD: ", Filename);
        Log.e("Idfichero BD: ", Idfichero);
        //Imagen redimensionada por drive a 1500px. Solo la redimensiona si es mayor a 1500 sino la muestra tal cual.
        new LoadImage().execute("https://drive.google.com/thumbnail?authuser=0&sz=s1500&id=" + Idfichero); //Visualizar
    }

    //***********************
    //drive
    private boolean comprobarGooglePlayServices() {
        int resultCode = GooglePlayServicesUtil.isGooglePlayServicesAvailable(this);
        if (resultCode != ConnectionResult.SUCCESS) {
            if (GooglePlayServicesUtil.isUserRecoverableError(resultCode)) {
                GooglePlayServicesUtil.getErrorDialog(resultCode, this,
                        PLAY_SERVICES_RESOLUTION_REQUEST).show();
            } else {
                finish();
            }
            return false;
        }
        return true;
    }

    private Drive obtenerServicioDrive(GoogleAccountCredential credencial) {
        return new Drive.Builder(AndroidHttp.newCompatibleTransport(),
                new GsonFactory(), credencial).build();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_imagen, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();
        if (id == R.id.descargar) {
            //Guardar en memoria interna mediante asynctask
            new GuardarImagenSD_A().execute();
        }
        if (id == R.id.compartir) {
            //Guardar en memoria interna mediante asynctask y compartir la imagen
            new CompartirImagenSD_A().execute();
        }
        return super.onOptionsItemSelected(item);
    }

    private class LoadImage extends AsyncTask<String, String, Bitmap> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = new ProgressDialog(ImagenGaleria.this);
            pDialog.setCancelable(false);
            pDialog.setMessage("Cargando imagen...");
            pDialog.show();

        }
        protected Bitmap doInBackground(String... args) {

            try {
                //****************************
                Log.e("Proves", "Entro try doInBackground" + Filename);
                if (Filename.equals("-")) {
                    //Si no tengo el nombre, buscar nombre imagen mediante servicios drive
                    try {
                        com.google.api.services.drive.model.File fichero = servicio.files().get(Idfichero).execute();

                        Log.e("Proves", "getOriginalFilename: " + fichero.getOriginalFilename());
                        Log.e("Proves", "getThumbnailLink: " + fichero.getThumbnailLink());
                        Log.e("Proves", "File Id:: " + fichero.getId());
                        Log.e("Proves", "File getWebContentLink:: " + fichero.getWebContentLink());
                        if (fichero.getOriginalFilename() != null) {
                            Filename = fichero.getOriginalFilename();
                        } else {
                            Filename = "-";
                        }
                        OpBD.ActualizarFilename(Idfichero, Filename);
                    } catch (IOException e) {
                        Log.e("Proves", "Error obtener drive: " + e);
                    }
                }
                //Obtener comentarios
                jParser = new JSONParser();
                String urlphp = "http://victorserranobargues.esy.es/Upv/views/imagengaleria.php?idfichero=" + Idfichero + "&filename=" + Filename;
                Log.e("urlphp: ", urlphp);
                json = new JSONObject();
                //JSON de la Url
                json = jParser.getJSONFromUrl(urlphp);
                String validartemp = String.valueOf(jParser.getJSONFromUrl(urlphp));
                String validar = validartemp.replaceAll("\"", "");
                //E/JSON Parser: Error parsing data org.json.JSONException: Value [] of type org.json.JSONArray cannot be converted to JSONObject
                //Para cuando sale este error me arrastra el comentario antiguo, lo he solucionado de esta forma.
                if (validar.equals("{Imagenes:[{comentario:}]}")) {
                    comentario_php = "";
                } else {
                    try {
                        // Getting JSON Array
                        user = new JSONArray();
                        user = json.getJSONArray("Imagenes");
                        c = new JSONObject();
                        c = user.getJSONObject(0);
                        //Miro la longitud para que no arrastre el comentario anterior
                        comentario_php = c.getString("comentario");
                        Log.e("comentario_php BD: ", comentario_php);

                    } catch (JSONException e) {
                        String error = e.toString();
                        Log.e("JSONException e: ", e.toString());
                        //Si da error pongo comentario a null sino arrastra el anterior.
                        if (error.length() > 1) {
                            comentario_php = "";
                        }
                    }
                }
                // Obtener Imagen
                Log.e("Valores BD: ", args[0]);
                URL url = new URL(args[0]);
                connection = (HttpURLConnection) url.openConnection();
                connection.setDoInput(true);
                connection.connect();
                input = connection.getInputStream();
                bitmap = BitmapFactory.decodeStream(input);
                return bitmap;
            } catch (OutOfMemoryError e) {
                Log.e("Memoria insuficiente: ", e.toString());
                return null;

            } catch (MalformedURLException e) {
                e.printStackTrace();
                Log.e("Valores BD2: ", e.toString());

            } catch (Exception e) {
                e.printStackTrace();
                Log.e("Valores BD3: ", e.toString());
            } finally {
                if (input != null) {
                    try {
                        input.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                if (connection != null) {
                    connection.disconnect();
                }
            }
            return null;
        }

        protected void onPostExecute(Bitmap image) {
            //Asigno el valor del comentario devuelto por json
            if (comentario_php.length() > 1) {
                comentario_foto.setText(comentario_php);
            }
            if (image != null) {
                Log.e(tag, "Ancho getWidth(): " + image.getWidth());
                Log.e(tag, "Alto getHeight(): " + image.getHeight());
                final int orientacion;
                if (image.getWidth() > image.getHeight()) {
                    //Si ancho mas grande horizontal landscape
                    orientacion = 1;
                } else {
                    //Si alto mas grande es vertical portrait
                    orientacion = 2;
                }
                //Guardo la imagen original para poder descargarla si se precisa
                bitmap = image;
                Bitmap bitmap2 = null;
                if (image.getWidth() > 1024 || image.getHeight() > 1024) {
                    bitmap2 = getResizedBitmapmaxsize(image, 1024, 1024);
                } else {
                    bitmap2 = image;
                }
                Log.e(tag, "Ancho2 getWidth(): " + bitmap.getWidth());
                Log.e(tag, "Alto2 getHeight(): " + bitmap.getHeight());
                image = null;
                photo.setImageBitmap(bitmap2);
                pDialog.dismiss();
                photo.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent i = new Intent(ImagenGaleria.this, ImagenGaleriaDetalle.class);
                        i.putExtra("Idfichero", Idfichero);
                        i.putExtra("Orientacion", orientacion);
                        startActivity(i);
                    }
                });


            } else {
                if (Idfichero.length() > 1) {
                    //Imagen redimensionada por drive a 1500px. Solo la redimensiona si es mayor a 1500 sino la muestra tal cual.
                    new LoadImage2().execute("https://drive.google.com/thumbnail?authuser=0&sz=s1500&id=" + Idfichero); //Visualizar
                }
            }
        }
    }

    private class LoadImage2 extends AsyncTask<String, String, Bitmap> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        protected Bitmap doInBackground(String... args) {

            try {
                Log.e("Valores BD: ", args[0]);
                URL url = new URL(args[0]);
                connection = (HttpURLConnection) url.openConnection();
                connection.setDoInput(true);
                connection.connect();
                input = connection.getInputStream();
                bitmap = BitmapFactory.decodeStream(input);
                return bitmap;
            } catch (OutOfMemoryError e) {
                Log.e("Memoria insuficiente: ", e.toString());
                return null;
            } catch (MalformedURLException e) {
                e.printStackTrace();
                Log.e("Valores BD2: ", e.toString());

            } catch (Exception e) {
                e.printStackTrace();
                Log.e("Valores BD3: ", e.toString());
            } finally {
                if (input != null) {
                    try {
                        input.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                if (connection != null) {
                    connection.disconnect();
                }
            }
            return null;
        }

        protected void onPostExecute(Bitmap image) {

            if (image != null) {
                Log.e(tag, "Ancho getWidth(): " + image.getWidth());
                Log.e(tag, "Alto getHeight(): " + image.getHeight());
                final int orientacion;
                if (image.getWidth() > image.getHeight()) {
                    //Si ancho mas grande horizontal landscape
                    orientacion = 1;
                } else {
                    //Si alto mas grande es vertical portrait
                    orientacion = 2;
                }
                if (image.getWidth() > 1024 || image.getHeight() > 1024) {
                    bitmap = getResizedBitmapmaxsize(image, 1024, 1024);
                } else {
                    bitmap = image;
                }
                Log.e(tag, "Ancho2 getWidth(): " + bitmap.getWidth());
                Log.e(tag, "Alto2 getHeight(): " + bitmap.getHeight());
                image = null;
                photo.setImageBitmap(bitmap);
                pDialog.dismiss();
                photo.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent i = new Intent(ImagenGaleria.this, ImagenGaleriaDetalle.class);
                        i.putExtra("Idfichero", Idfichero);
                        i.putExtra("Orientacion", orientacion);
                        startActivity(i);
                    }
                });
            } else {
                if (pDialog != null) {
                    if (pDialog.isShowing()) {
                        pDialog.dismiss();
                    }
                }
                Toast.makeText(ImagenGaleria.this, "Error de conexion", Toast.LENGTH_SHORT).show();
                limpiarmemoria();
                finish();

            }
        }
    }

    @Override
    public void onBackPressed() {
        limpiarmemoria();
        finish();
    }

    private void limpiarmemoria() {
        comentario_php = "";
        if (json != null) {
            json = null;
        }
        if (jParser != null) {
            jParser = null;
        }
        if (user != null) {
            user = null;
        }
        if (c != null) {
            c = null;
        }
        if (bitmap != null) {
            photo = null;
            bitmap.recycle();
            bitmap = null;
        }

    }
    //Reajusta el bitmap en funcion del maximo indicado
    public static Bitmap getResizedBitmapmaxsize(Bitmap bm, int newWidth, int newHeight) {
        int maxHeight = newWidth;
        int maxWidth = newHeight;
        float scale = Math.min(((float) maxHeight / bm.getWidth()), ((float) maxWidth / bm.getHeight()));

        Matrix matrix = new Matrix();
        matrix.postScale(scale, scale);
        Bitmap resizedBitmap = Bitmap.createBitmap(bm, 0, 0, bm.getWidth(), bm.getHeight(), matrix, true);
        return resizedBitmap;
    }

    private class GuardarImagenSD_A extends AsyncTask<Void, Void, Void> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = ProgressDialog.show(ImagenGaleria.this, "Descargando Imagen...", "Espere por favor...", true);

        }

        @Override
        protected Void doInBackground(Void... params) {
            if (Filename.equals("-")) {
                String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss",
                        Locale.ENGLISH).format(new Date());
                Filename = timeStamp + ".jpg";
            }
            //Aquí ejecutamos nuestras tareas costosas
            String PATH = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES) + "/" + "photos_share" + "/";

            try {
                File folder = new File(PATH, Filename);
                File folder2 = new File(PATH);
                if (!folder2.exists()) {
                    folder2.mkdir();//If there is no folder it will be created.
                }
                if (folder.createNewFile()) {
                    folder.createNewFile();
                }
                Bitmap bitmap2 = bitmap;
                FileOutputStream out = new FileOutputStream(PATH + Filename);
                bitmap2.compress(Bitmap.CompressFormat.PNG, 100, out); //100 es cualidad maxima 0 calidad minima de compresion
                out.flush();
                out.close();
                bitmap2 = null;
                pDialog.dismiss();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            pDialog.dismiss();
            Toast.makeText(ImagenGaleria.this, "Imagen guardada en su dispositivo", Toast.LENGTH_SHORT).show();
        }
    }

    private class CompartirImagenSD_A extends AsyncTask<Void, Void, Void> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = ProgressDialog.show(ImagenGaleria.this, "Descargando Imagen...", "Espere por favor...", true);

        }
        @Override
        protected Void doInBackground(Void... params) {
            if (Filename.equals("-")) {
                String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss",
                        Locale.ENGLISH).format(new Date());
                Filename = timeStamp + ".jpg";
            }
            //Aquí ejecutamos nuestras tareas costosas
            String PATH = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES) + "/" + "photos_share" + "/";

            try {
                folder = new File(PATH, Filename);
                File folder2 = new File(PATH);
                if (!folder2.exists()) {
                    folder2.mkdir();//If there is no folder it will be created.
                }
                if (folder.createNewFile()) {
                    folder.createNewFile();
                }
                Bitmap bitmap2 = bitmap;
                FileOutputStream out = new FileOutputStream(PATH + Filename);
                bitmap2.compress(Bitmap.CompressFormat.PNG, 100, out); //100 es cualidad maxima 0 calidad minima de compresion
                out.flush();
                out.close();
                bitmap2 = null;
                pDialog.dismiss();

            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            pDialog.dismiss();
            Uri bmpUri = Uri.fromFile(folder);

            if (bmpUri != null) {
                // Construimos ShareIntent con el link de la imagen
                Intent shareIntent = new Intent();
                shareIntent.setAction(Intent.ACTION_SEND);
                shareIntent.putExtra(Intent.EXTRA_STREAM, bmpUri);
                shareIntent.setType("image/*");
                startActivity(Intent.createChooser(shareIntent, "Share Image"));
            } else {
                Toast.makeText(ImagenGaleria.this, "No se ha podido compartir la imagen", Toast.LENGTH_SHORT).show();
            }
        }
    }
}//Fin ImagenGaleria



