package com.vserrano.photos_share;

import android.app.ProgressDialog;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.widget.Toast;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

public class ImagenGaleriaDetalle extends AppCompatActivity {
    private ImagenZoom img;
    private static Bitmap bitmap;
    private static String tag = "PhotosShare";
    private String Idfichero;
    private ProgressDialog pDialog;
    int orientacion;
    static InputStream input=null;
    static HttpURLConnection connection=null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.imagen_galeria_detalle);

        Bundle b = this.getIntent().getExtras();
        Idfichero=b.getString("Idfichero");
        orientacion=b.getInt("Orientacion");
        if(Idfichero.length()>1){
            //Imagen redimensionada por drive a 1500px. Solo la redimensiona si es mayor a 1500 sino la muestra tal cual.
            new LoadImage().execute("https://drive.google.com/thumbnail?authuser=0&sz=s1500&id="+Idfichero); //Visualizar
        }
    }

    private class LoadImage extends AsyncTask<String, String, Bitmap> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(ImagenGaleriaDetalle.this);
            pDialog.setCancelable(false);
            pDialog.setMessage("Cargando imagen...");
            pDialog.show();
        }
        protected Bitmap doInBackground(String... args) {

            try {
                Log.e("Valores BD1: ", args[0]);
                URL url = new URL(args[0]);
                connection = (HttpURLConnection) url.openConnection();
                connection.setDoInput(true);
                connection.connect();
                input = connection.getInputStream();
                bitmap = BitmapFactory.decodeStream(input);
                return bitmap;
            } catch (OutOfMemoryError e) {
                Log.e("Memoria insuficiente: ", e.toString());
                return null;
            }catch (MalformedURLException e) {
                e.printStackTrace();
                Log.e("Valores BD2: ", e.toString());

            } catch (Exception e) {
                e.printStackTrace();
                Log.e("Valores BD3: ", e.toString());
            }finally {
                if(input!=null){
                    try {
                        input.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                if(connection!=null){
                    connection.disconnect();
                }
            }
            return null;
        }

        protected void onPostExecute(Bitmap image) {
            Log.e("Valores BD4: ", "Entro onPostExecute");

            if(image != null){
                Log.e(tag,"Ancho getWidth(): "+image.getWidth());
                Log.e(tag,"Alto getHeight(): "+image.getHeight());
                if(image.getWidth()>1024 || image.getHeight()>1024) {
                    bitmap = getResizedBitmapmaxsize(image, 1024, 1024);
                }else{
                    bitmap=image;
                }
                Log.e(tag,"Ancho2 getWidth(): "+bitmap.getWidth());
                Log.e(tag,"Alto2 getHeight(): "+bitmap.getHeight());
                image=null;
                if (orientacion==1) {
                    // programmitically set screen orientation of activity (landscape)
                    setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
                }else{
                    // programmitically set screen orientation of activity (portrait)
                    setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
                }
                //Imagen con zoom
                img = (ImagenZoom)findViewById(R.id.imageView);
                img.setMaxZoom(4f);
                img.setImageBitmap(bitmap);
                //****************************
                if (pDialog!=null)
                {
                    if (pDialog.isShowing())
                    {
                        pDialog.dismiss();
                    }
                }
            }else{

                if(Idfichero.length()>1){
                    //Imagen redimensionada por drive a 1500px. Solo la redimensiona si es mayor a 1500 sino la muestra tal cual.
                    new LoadImage2().execute("https://drive.google.com/thumbnail?authuser=0&sz=s1500&id="+Idfichero); //Visualizar
                }
            }
        }
    }

    //Reajusta el bitmap en funcion del maximo indicado
    public static Bitmap getResizedBitmapmaxsize(Bitmap bm, int newWidth, int newHeight) {
        int maxHeight = newWidth;
        int maxWidth = newHeight;
        float scale = Math.min(((float) maxHeight / bm.getWidth()), ((float) maxWidth / bm.getHeight()));

        Matrix matrix = new Matrix();
        matrix.postScale(scale, scale);
        Bitmap resizedBitmap = Bitmap.createBitmap(bm, 0, 0, bm.getWidth(), bm.getHeight(), matrix, true);
        return resizedBitmap;
    }

    @Override
    public void onBackPressed()
    {
        limpiarmemoria();
        finish();
    }

    private void limpiarmemoria(){
        if(bitmap!=null){
            img=null;
            bitmap.recycle();
            bitmap=null;
        }
    }

    private class LoadImage2 extends AsyncTask<String, String, Bitmap> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }
        protected Bitmap doInBackground(String... args) {

            try {
                Log.e("Valores BD1: ", args[0]);
                URL url = new URL(args[0]);
                connection = (HttpURLConnection) url.openConnection();
                connection.setDoInput(true);
                connection.connect();
                input = connection.getInputStream();
                bitmap = BitmapFactory.decodeStream(input);
                return bitmap;
            } catch (OutOfMemoryError e) {
                Log.e("Memoria insuficiente: ", e.toString());
                return null;
            }catch (MalformedURLException e) {
                e.printStackTrace();
                Log.e("Valores BD2: ", e.toString());

            } catch (Exception e) {
                e.printStackTrace();
                Log.e("Valores BD3: ", e.toString());
            }finally {
                if(input!=null){
                    try {
                        input.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                if(connection!=null){
                    connection.disconnect();
                }
            }
            return null;
        }

        protected void onPostExecute(Bitmap image) {
            Log.e("Valores BD4: ", "Entro onPostExecute");

            if(image != null){
                Log.e(tag,"Ancho getWidth(): "+image.getWidth());
                Log.e(tag,"Alto getHeight(): "+image.getHeight());
                if(image.getWidth()>1024 || image.getHeight()>1024) {
                    bitmap = getResizedBitmapmaxsize(image, 1024, 1024);
                }else{
                    bitmap=image;
                }
                Log.e(tag,"Ancho2 getWidth(): "+bitmap.getWidth());
                Log.e(tag,"Alto2 getHeight(): "+bitmap.getHeight());
                image=null;
                //****************************
                if (orientacion==1) {
                    // programmitically set screen orientation of activity (landscape)
                    setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
                }else{
                    // programmitically set screen orientation of activity (portrait)
                    setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
                }
                //Imagen con zoom
                img = (ImagenZoom)findViewById(R.id.imageView);
                img.setMaxZoom(4f);
                img.setImageBitmap(bitmap);
                //****************************
                if (pDialog!=null)
                {
                    if (pDialog.isShowing())
                    {
                        pDialog.dismiss();
                    }
                }
            }else{
                if (pDialog!=null)
                {
                    if (pDialog.isShowing())
                    {
                        pDialog.dismiss();
                    }
                }
                Toast.makeText(ImagenGaleriaDetalle.this, "Error de conexion", Toast.LENGTH_SHORT).show();
                limpiarmemoria();
                finish();
            }
        }
    }

}
