package com.vserrano.photos_share;


import android.app.Activity;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.ContextWrapper;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import static com.vserrano.photos_share.UtilidadesDrive.nombreCuenta;

public class MiPerfil extends Activity{
    static final int SOLICITUD_HACER_FOTOGRAFIA_PERFIL = 6;
    static final int SOLICITUD_SELECCIONAR_FOTOGRAFIA_PERFIL = 5;
    static final int PIC_CROP = 7;
    private static Uri uriFichero;
    private Uri fotoperfil;
    static com.github.siyamed.shapeimageview.CircularImageView photo=null;
    private TextView aliasT;
    private TextView cuenta;
    private TextView nombrecuenta;
    private TextView cimagen;
    private ImageButton btn_galeria;
    private ImageButton btn_camara;
    private String alias_foto;
    private String alias_nombre;
    OpcionesBD OpBD;
    private EditText alias;
    File f1;//ruta camara
    File f3;//ruta pic_crop
    CheckBox baja,media,alta;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.mi_perfil);
        //************************************
        //guardamos en un string el valor de la BD nombre usuario .
        final SharedPreferences prefs = getSharedPreferences("Preferencias",
                Context.MODE_PRIVATE);
        alias_nombre=OpBD.BuscarAlias(prefs.getString("nombreCuenta", null));
        alias=(EditText)findViewById(R.id.alias);
        alias.setText(alias_nombre);

        //******************************************
        //Checkbox calidad imagen
        baja=(CheckBox)findViewById(R.id.baja);
        media=(CheckBox)findViewById(R.id.media);
        alta=(CheckBox)findViewById(R.id.alta);
        //Marcar calidad de la BD
        int calidad=OpBD.ObtenerCalidad(prefs.getString("nombreCuenta", null));
        switch (calidad){
            case 1:
                baja.setChecked(true);
                break;
            case 2:
                media.setChecked(true);
                break;
            case 3:
                alta.setChecked(true);
                break;
        }
        //Si modificamos la calidad
        baja.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (baja.isChecked()) {
                    //checked
                    //Toast.makeText(MiPerfil.this, "Checked", Toast.LENGTH_SHORT).show();
                    OpBD.AsignarCalidad(1,prefs.getString("nombreCuenta", null));
                    media.setChecked(false);
                    alta.setChecked(false);
                } else {
                    baja.setChecked(true);
                    //not checked
                    //Toast.makeText(MiPerfil.this, "not checked", Toast.LENGTH_SHORT).show();
                }
            }
        });
        media.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (media.isChecked()) {
                    //checked
                    //Toast.makeText(MiPerfil.this, "Checked", Toast.LENGTH_SHORT).show();
                    OpBD.AsignarCalidad(2,prefs.getString("nombreCuenta", null));
                    baja.setChecked(false);
                    alta.setChecked(false);
                } else {
                    media.setChecked(true);
                    //not checked
                    //Toast.makeText(MiPerfil.this, "not checked", Toast.LENGTH_SHORT).show();
                }
            }
        });
        alta.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (alta.isChecked()) {
                    //checked
                    //Toast.makeText(MiPerfil.this, "Checked", Toast.LENGTH_SHORT).show();
                    OpBD.AsignarCalidad(3,prefs.getString("nombreCuenta", null));
                    baja.setChecked(false);
                    media.setChecked(false);
                } else {
                    alta.setChecked(true);
                    //not checked
                    //Toast.makeText(MiPerfil.this, "not checked", Toast.LENGTH_SHORT).show();
                }
            }
        });
        //*******************************************
        photo = (com.github.siyamed.shapeimageview.CircularImageView)findViewById(R.id.img_perfil2);
        String rutaimg=OpBD.BuscarRutaFotoPerfil(prefs.getString("nombreCuenta", null));
        if(rutaimg.length()>1) {

                File imgFile = new File(rutaimg);

                if (imgFile.exists()) {

                    Bitmap myBitmap = BitmapFactory.decodeFile(imgFile.getAbsolutePath());
                    photo.setImageBitmap(myBitmap);

                }
        }

        //*******************************************
        aliasT=(TextView)findViewById(R.id.nombreuser);
        cuenta=(TextView)findViewById(R.id.cuenta);
        nombrecuenta=(TextView)findViewById(R.id.nombrecuenta);
        cimagen=(TextView)findViewById(R.id.cimagen);
        Typeface Advertising=Typeface.createFromAsset(getAssets(),"fonts/Advertising.ttf");
        aliasT.setTypeface(Advertising);
        cuenta.setTypeface(Advertising);
        cimagen.setTypeface(Advertising);
        alias_foto=prefs.getString("nombreCuenta", null);
        nombrecuenta.setText(prefs.getString("nombreCuenta", null));
        btn_galeria = (ImageButton) findViewById(R.id.btn_galeria);
        btn_galeria.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Mirar si hay modificaciones y guardamos
                guardarnombreusuario();
                seleccionarFoto(v);
            }
        });
        btn_camara = (ImageButton) findViewById(R.id.btn_camara);
        btn_camara.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Mirar si hay modificaciones y guardamos
                guardarnombreusuario();
                hacerFoto(v);
            }
        });


    }

    @Override
    public void onBackPressed()
    {
        guardarnombreusuario();
        finish();

    }

    private void guardarnombreusuario() {
        String aliasTemp=alias.getText().toString();
        if(aliasTemp.equals(alias_nombre)){
            Log.e("Valores nombreuser: ", "Iguales");
        }else{
            Log.e("Valores nombreuser: ", "Diferentes");
            OpBD.ActualizarAlias(aliasTemp,nombrecuenta.getText().toString());
        }

    }

    @Override
    protected void onActivityResult(final int requestCode,
                                    final int resultCode, final Intent data) {
        switch (requestCode) {
            //Camara
            case SOLICITUD_HACER_FOTOGRAFIA_PERFIL:
                if (resultCode == Activity.RESULT_OK) {
                    Log.e("Ruta camera: ", String.valueOf(uriFichero));
                    //Operación de captura
                    performCrop();
                }
                break;
            //Recortar imagen
            case PIC_CROP:
                if (resultCode == Activity.RESULT_OK) {
                    Bitmap thumbnail= null;
                    try {
                        thumbnail = MediaStore.Images.Media.getBitmap(MiPerfil.this
                                .getContentResolver(), fotoperfil);
                        OpBD.ActualizarRutaFotoPerfil(f3.toString(),nombrecuenta.getText().toString());
                    } catch (IOException e) {
                        //e.printStackTrace();
                        Toast.makeText(MiPerfil.this, "No se puede recortar", Toast.LENGTH_SHORT).show();
                        try {
                            thumbnail = MediaStore.Images.Media.getBitmap(MiPerfil.this
                                    .getContentResolver(), uriFichero);
                            OpBD.ActualizarRutaFotoPerfil(f1.toString(),nombrecuenta.getText().toString());
                        } catch (IOException e1) {
                            e1.printStackTrace();
                        }

                    }
                    photo.setImageBitmap(thumbnail);
                }
                break;
            //Galeria
            case SOLICITUD_SELECCIONAR_FOTOGRAFIA_PERFIL:
                if (resultCode == Activity.RESULT_OK) {
                    Uri ficheroSeleccionado = data.getData();
                    String[] proyeccion = { MediaStore.Images.Media.DATA };
                    Cursor cursor = managedQuery(ficheroSeleccionado, proyeccion,
                            null, null, null);
                    int column_index =
                            cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
                    cursor.moveToFirst();
                    f1 = new File(cursor.getString(column_index));

                    uriFichero = Uri.fromFile(new java.io.File(cursor.getString(column_index)));
                    //picUri=uriFichero;
                    Log.e("Ruta camera: ", String.valueOf(uriFichero));

                    //Operación de captura
                    performCrop();

                }
                break;

        }
    }
    //Operación de captura
    private void performCrop(){
        try {
            //Recortar Imagen
            Intent cropIntent = new Intent("com.android.camera.action.CROP");
            //indicate image type and Uri
            cropIntent.setDataAndType(uriFichero, "image/*");
            //set crop properties
            cropIntent.putExtra("crop", "true");
            //indicate aspect of desired crop
            cropIntent.putExtra("aspectX", 1);
            cropIntent.putExtra("aspectY", 1);
            //indicate output X and Y
            cropIntent.putExtra("outputX", 256);
            cropIntent.putExtra("outputY", 256);
            //******************
            String[] parts = alias_foto.split("@");

            f3 = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES),"/"+parts[0]+"_fotoperfil.jpg");
            fotoperfil=Uri.fromFile(f3);
            Log.e("Ruta PublicDirectory : ", String.valueOf(f3.getAbsolutePath()));
            Log.e("Ruta FotoPerfil : ", String.valueOf(fotoperfil));

            try {
                f3.createNewFile();

            } catch (IOException ex) {
                Log.e("io", ex.getMessage());
            }
            cropIntent.putExtra(MediaStore.EXTRA_OUTPUT, fotoperfil);
            startActivityForResult(cropIntent, PIC_CROP);
        }
        catch(ActivityNotFoundException anfe){
            //display an error message
            String errorMessage = "Su dispositivo no soporta la acción de recortar!";
            Toast toast = Toast.makeText(this, errorMessage, Toast.LENGTH_SHORT);
            toast.show();
        }
    }

    public void hacerFoto(View v) {
        String mediaStorageDir =
                Environment.getExternalStoragePublicDirectory(
                        Environment.DIRECTORY_PICTURES).getPath();

        String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss",
                Locale.ENGLISH).format(new Date());
        java.io.File dest=new java.io.File(mediaStorageDir +
                java.io.File.separator + "PERFIL_TMP" + timeStamp + ".jpg");
        uriFichero = Uri.fromFile(dest);
        Intent cameraIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        cameraIntent.putExtra(MediaStore.EXTRA_OUTPUT, uriFichero);
        startActivityForResult(cameraIntent, SOLICITUD_HACER_FOTOGRAFIA_PERFIL);
    }

    public void seleccionarFoto(View v) {
        Intent seleccionFotografiaIntent = new Intent();
        seleccionFotografiaIntent.setType("image/*");
        seleccionFotografiaIntent.setAction(Intent.ACTION_PICK);
        startActivityForResult(Intent.createChooser(seleccionFotografiaIntent,
                "Seleccionar fotografía"),SOLICITUD_SELECCIONAR_FOTOGRAFIA_PERFIL);

    }
}
