package com.vserrano.photos_share;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Typeface;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.squareup.picasso.Picasso;

import java.util.List;


public class MyRecyclerAdapter extends RecyclerView.Adapter<MyRecyclerAdapter.ViewHolder> {

    private List<ImagenDrive> items;
    private int itemLayout;
    private Context context;
    private ImagenDrive imagendrive;

    public MyRecyclerAdapter(Context context, List<ImagenDrive> items, int itemLayout) {
        this.context = context;
        this.items = items;
        this.itemLayout = itemLayout;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View v = LayoutInflater.from(parent.getContext()).inflate(itemLayout, parent, false);
        return new ViewHolder(v);
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int position) {
        final ImagenDrive item = items.get(position);
        imagendrive=item;
        Typeface Advertising=Typeface.createFromAsset(holder.itemView.getContext().getAssets(),"fonts/Advertising.ttf");
        holder.info.setTypeface(Advertising);
        holder.filename.setText(item.getFilename());
        holder.comentario.setText(item.getComentario());
        Picasso.with(context).load(item.getUrl_img()).into(holder.imagenmostrar);
        holder.info.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //Boton mas info
                if(view.getContext()!=null&&item.getIdfichero().length()>1) {
                    Intent i = new Intent(view.getContext(), ImagenGaleria.class);
                    i.putExtra("Idfichero", item.getIdfichero());
                    view.getContext().startActivity(i);
                }
            }
        });
        holder.imagenmostrar.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                crear_dialogo().show();
                return false;
            }
        });
        holder.itemView.setTag(item);
    }
    private Dialog crear_dialogo(){
        AlertDialog.Builder builder = new AlertDialog.Builder(context);
        builder.setCancelable(false);
        builder.setMessage("¿Desea eliminar la imagen?");
        builder.setPositiveButton("Aceptar", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {
                Toast.makeText(context, " Eliminada", Toast.LENGTH_SHORT).show();
            }
        });

        builder.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });

        return builder.create();
    }

    @Override
    public int getItemCount() {
        return items.size();
    }

    public static class ViewHolder extends RecyclerView.ViewHolder {

        public ImageView imagenmostrar;
        public TextView filename;
        public TextView comentario;
        public Button info;

        public ViewHolder(View itemView) {
            super(itemView);

            imagenmostrar = (ImageView) itemView.findViewById(R.id.imagenmostrar);
            filename = (TextView) itemView.findViewById(R.id.filename);
            comentario = (TextView) itemView.findViewById(R.id.comentario);
            info = (Button) itemView.findViewById(R.id.btn_info);
        }
    }
}
