package com.vserrano.photos_share;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.Typeface;
import android.media.ExifInterface;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;
import android.view.ContextMenu;
import android.view.MenuItem;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.github.siyamed.shapeimageview.CircularImageView;
import com.github.siyamed.shapeimageview.RoundedImageView;
import com.google.api.client.googleapis.extensions.android.gms.auth.UserRecoverableAuthIOException;
import com.google.api.client.http.FileContent;
import com.google.api.services.drive.model.File;
import com.google.api.services.drive.model.ParentReference;

import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicHeader;
import org.apache.http.protocol.HTTP;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.Locale;
import static com.vserrano.photos_share.UtilidadesDrive.*;
import static com.vserrano.photos_share.ActividadPrincipal.*;

public class Nueva_photo extends Activity {

    private static String tag = "PhotosShare";

    static com.github.siyamed.shapeimageview.RoundedImageView photo=null;

    private Bitmap miniatura = null;
    private Bitmap temporal = null;
    private Bitmap bitmapGrises = null;
    private Bitmap bitmapSepia = null;
    private Bitmap bitmapMarco = null;
    private Bitmap bitmapActual = null;
    private Bitmap fotoportada = null;
    private int imagencalidad=1024;//Por defecto
    private ImageView ivDisplayH = null;
    private TextView mostrarF;
    private static Uri uriFichero;
    private static Uri uriFicheroG;
    private static String nombreimagen=null;
    private static String comentarioimagen="";
    static final int SOLICITUD_SELECCIONAR_FOTOGRAFIA = 3;
    static final int SOLICITUD_HACER_FOTOGRAFIA = 4;
    Button tomar_nuevafoto;
    Button obtener_nuevafoto;
    private LinearLayout L_layout;
    private LinearLayout R_layout;
    java.io.File dest;
    OpcionesBD OpBD;
    ImageView btn_efecto;
    ImageView btn_guardar;
    EditText comentario;
    private TextView tv_comtitulo;
    private TextView tv_efecto;
    private TextView tv_guardar;
    private ProgressDialog pDialog;
    private int fototrabajar=1;//1 imagen redimensionada, 2 imagen original

    static String PATH = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES) + "/" + "photos_share" + "/";

    static com.github.siyamed.shapeimageview.CircularImageView photo_novios=null;

    static {
        System.loadLibrary("photosshare");
    }

    public native void convertirGrises(Bitmap bitmapIn, Bitmap bitmapOut);
    public native void convertirSepia(Bitmap bitmapIn, Bitmap bitmapOut);
    public native void convertirMarco(Bitmap bitmapIn, Bitmap bitmapOut);

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.nueva_photo);
        //Marcar calidad de la BD
        final SharedPreferences prefs = getSharedPreferences("Preferencias",
                Context.MODE_PRIVATE);
        int calidad=OpBD.ObtenerCalidad(prefs.getString("nombreCuenta", null));
        switch (calidad){
            case 1:
                imagencalidad=512;
                break;
            case 2:
                imagencalidad=1024;
                break;
            case 3:
                imagencalidad=1536;
                break;
        }
        Log.e(tag,"ImagenCalidad: "+imagencalidad);

        L_layout=(LinearLayout)findViewById(R.id.L_layout);
        R_layout=(LinearLayout) findViewById(R.id.R_layout);
        L_layout.setVisibility(View.VISIBLE);
        R_layout.setVisibility(View.GONE);

        photo_novios = (CircularImageView)findViewById(R.id.img_novios);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB) {
            photo_novios.setLayerType(View.LAYER_TYPE_SOFTWARE, null);
        }

        fotoportada = BitmapFactory.decodeResource(getResources(), R.drawable.selfie2);
        photo_novios.setImageBitmap(fotoportada);
        //Asignar tipo fuente
        Typeface Advertising=Typeface.createFromAsset(getAssets(),"fonts/Advertising.ttf");
        tv_comtitulo=(TextView)findViewById(R.id.tv_comtitulo);
        tv_efecto=(TextView)findViewById(R.id.tv_efecto);
        tv_guardar=(TextView)findViewById(R.id.tv_guardar);
        tv_comtitulo.setTypeface(Advertising);
        tv_efecto.setTypeface(Advertising);
        tv_guardar.setTypeface(Advertising);
        tomar_nuevafoto=(Button)findViewById(R.id.tomar_nuevafoto);
        tomar_nuevafoto.setTypeface(Advertising);
        tomar_nuevafoto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hacerFoto(v);
            }
        });
        obtener_nuevafoto=(Button)findViewById(R.id.obtener_nuevafoto);
        obtener_nuevafoto.setTypeface(Advertising);
        obtener_nuevafoto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                seleccionarFoto(v);
            }
        });
        Log.i(tag, "Imagen antes de modificar");
        photo = (RoundedImageView)findViewById(R.id.ivDisplayH);

        BitmapFactory.Options options = new BitmapFactory.Options();
        // Asegurar que la imagen tiene 24 bits de color
        options.inPreferredConfig = Bitmap.Config.ARGB_8888;

        //********************
        //Context menu

        btn_efecto=(ImageView)findViewById(R.id.btn_efecto);
        btn_efecto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                registerForContextMenu(v);
                openContextMenu(v);
            }
        });
        comentario=(EditText)findViewById(R.id.comentario);
        comentario.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //v.setFocusable(true);//disables the focus of the editText
                v.setFocusableInTouchMode(true);
                //** this code is for enabling the keyboard at the first click on the editText
                if(v.isFocused())//the code is optional, because at the second click the keyboard shows by itself
                {
                    InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.showSoftInput(v, InputMethodManager.SHOW_IMPLICIT);
                }
            }
        });
        //Boton guardar
        btn_guardar=(ImageView)findViewById(R.id.btn_guardar);
        btn_guardar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new SincronizarNuevaFoto().execute();
            }
        });

        //**********************
    }
    //******************************* Context Menu
    @Override
    public void onCreateContextMenu(ContextMenu menu, View v, ContextMenu.ContextMenuInfo menuInfo) {
        super.onCreateContextMenu(menu, v, menuInfo);
        menu.setHeaderTitle("Efecto Imagen");
        menu.add(0, v.getId(), 0, "ORIGINAL");
        menu.add(0, v.getId(), 0, "CON MARCO");
        menu.add(0, v.getId(), 0, "SEPIA");
        menu.add(0, v.getId(), 0, "ESCALA DE GRISES");
    }
    @Override
    public boolean onContextItemSelected(MenuItem item) {
        switch (item.getTitle().toString()){
            case "ORIGINAL":
                //saveImageToInternalStorage(bitmapActual);
                onResetImagen();
                break;
            case "CON MARCO":
                onConvertirMarco();
                break;
            case "SEPIA":
                onConvertirSepia();
                break;
            case "ESCALA DE GRISES":
                onConvertirGrises();
                break;

        }
        return true;
    }
    //*********************************

    public void onResetImagen() {
        Log.i(tag, "Resetear Imagen");
        try {
            //Obtener bitmap actual que ya esta redimensionado y girado;
            bitmapActual = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFichero);
            Log.e(tag,"onResetImagen uri: "+uriFichero);
            if (bitmapActual!=null) {
                fototrabajar=1;
                if (bitmapActual.getWidth() > 512 || bitmapActual.getHeight() > 512) {
                    miniatura = getResizedBitmapmaxsize(bitmapActual, 512, 512);
                } else {
                    miniatura = bitmapActual;
                }
                photo.setImageBitmap(miniatura);
            }else{
                //Obtener bitmap original;
                fototrabajar=2;
                bitmapActual = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFicheroG);
                Log.e(tag,"onResetImagen uri: "+uriFichero);
                if (bitmapActual!=null) {
                    if (bitmapActual.getWidth() > 512 || bitmapActual.getHeight() > 512) {
                        miniatura = getResizedBitmapmaxsize(bitmapActual, 512, 512);
                    } else {
                        miniatura = bitmapActual;
                    }
                    photo.setImageBitmap(miniatura);
                }else {
                    //No ha podido hacer una copia de la original.
                    // Informamos al usuario y cerramos.
                    Toast.makeText(this, "No se puede acceder a la imagen seleccionada!", Toast.LENGTH_LONG).show();
                    Toast.makeText(this, "Seleccione otra por favor!", Toast.LENGTH_LONG).show();
                    limpiarmemoria();
                    finish();
                }
            }
            miniatura=null;

        } catch (IOException e) {
            e.printStackTrace();
        }catch (Throwable ex) {
            ex.printStackTrace();
            if (ex instanceof OutOfMemoryError) {
                Toast.makeText(this, "Excedio la memoria, cierre la aplicación y vuelve a abrirla", Toast.LENGTH_LONG).show();
            }
        }
    }
    public void onConvertirGrises() {
        Log.i(tag,"Conversion a escala de grises");

        try {
            if(fototrabajar==1) {
                //Obtener bitmap actual que ya esta redimensionado y girado
                temporal = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFichero);
            }else{
                //Imagen original
                temporal = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFicheroG);
            }

            Log.e(tag,"temporal.getWidth(): "+temporal.getWidth());
            Log.e(tag,"temporal.getHeight(): "+temporal.getHeight());
            bitmapGrises = Bitmap.createBitmap(temporal.getWidth(),temporal.getHeight(), Bitmap.Config.ARGB_8888);
            convertirGrises(temporal, bitmapGrises);
            bitmapActual=Bitmap.createBitmap(bitmapGrises);
            temporal.recycle();
            temporal=null;
            if (bitmapActual.getWidth() > 512 || bitmapActual.getHeight() > 512) {
                miniatura = getResizedBitmapmaxsize(bitmapActual, 512, 512);
            } else {
                miniatura = bitmapActual;
            }
            //Liberar memoria
            bitmapGrises.recycle();
            bitmapGrises=null;


            photo.setImageBitmap(miniatura);
            miniatura=null;
        } catch (IOException e) {
            e.printStackTrace();
        }catch (Throwable ex) {
            ex.printStackTrace();
            if (ex instanceof OutOfMemoryError) {
                Toast.makeText(this, "Excedio la memoria, no se pudo convertir en escala de grises", Toast.LENGTH_LONG).show();
            }
        }
    }
    public void onConvertirMarco() {
        Log.i(tag,"Poner Marco");

        try {
            if(fototrabajar==1) {
                //Obtener bitmap actual que ya esta redimensionado y girado
                temporal = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFichero);
            }else{
                //Imagen original
                temporal = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFicheroG);
            }

            bitmapMarco = Bitmap.createBitmap(temporal.getWidth(),temporal.getHeight(), Bitmap.Config.ARGB_8888);
            convertirMarco(temporal, bitmapMarco);
            bitmapActual=Bitmap.createBitmap(bitmapMarco);
            temporal.recycle();
            temporal=null;
            if (bitmapActual.getWidth() > 512 || bitmapActual.getHeight() > 512) {
                miniatura = getResizedBitmapmaxsize(bitmapActual, 512, 512);
            } else {
                miniatura = bitmapActual;
            }
            //Liberar memoria
            bitmapMarco.recycle();
            bitmapMarco=null;

            photo.setImageBitmap(miniatura);
            miniatura=null;
        } catch (IOException e) {
            e.printStackTrace();
        }catch (Throwable ex) {
            ex.printStackTrace();
            if (ex instanceof OutOfMemoryError) {
                Toast.makeText(this, "Excedio la memoria, no se pudo poner el marco", Toast.LENGTH_LONG).show();
            }
        }

    }

    public void onConvertirSepia() {
        Log.i(tag,"Conversion a Sepia");
        try {
            if(fototrabajar==1) {
                //Obtener bitmap actual que ya esta redimensionado y girado
                temporal = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFichero);
            }else{
                //Imagen original
                temporal = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFicheroG);
            }

            bitmapSepia = Bitmap.createBitmap(temporal.getWidth(),temporal.getHeight(), Bitmap.Config.ARGB_8888);
            convertirSepia(temporal, bitmapSepia);
            bitmapActual=Bitmap.createBitmap(bitmapSepia);
            temporal.recycle();
            temporal=null;
            if (bitmapActual.getWidth() > 512 || bitmapActual.getHeight() > 512) {
                miniatura = getResizedBitmapmaxsize(bitmapActual, 512, 512);
            } else {
                miniatura = bitmapActual;
            }
            //Liberar memoria
            bitmapSepia.recycle();
            bitmapSepia=null;

            //******************
            photo.setImageBitmap(miniatura);
            miniatura=null;
        } catch (IOException e) {
            e.printStackTrace();
        }catch (Throwable ex) {
            ex.printStackTrace();
            if (ex instanceof OutOfMemoryError) {
                Toast.makeText(this, "Excedio la memoria, no se pudo convertir en sepia", Toast.LENGTH_LONG).show();
            }
        }
    }

    public void seleccionarFoto(View v) {
        if (nombreCuenta == null) {
            mostrarMensaje(this,"Debes seleccionar una cuenta de Google Drive");
        } else {
            String mediaStorageDir =
                    Environment.getExternalStoragePublicDirectory(
                            Environment.DIRECTORY_PICTURES).getPath();

            String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss",
                    Locale.ENGLISH).format(new Date());
            dest=new java.io.File(mediaStorageDir +
                    java.io.File.separator +"/" + "photos_share" + "/" + "IMG_" +imagencalidad+ "_" + timeStamp + ".jpg");
            uriFichero = Uri.fromFile(dest);
            nombreimagen="IMG_" +imagencalidad+ "_" + timeStamp + ".jpg";
            Log.e(tag,"SOLICITUD_SELECCIONAR_FOTOGRAFIA1 uri: "+uriFichero);

            Intent seleccionFotografiaIntent = new Intent();
            seleccionFotografiaIntent.setType("image/*");
            seleccionFotografiaIntent.setAction(Intent.ACTION_PICK);
            startActivityForResult(Intent.createChooser(seleccionFotografiaIntent,
                    "Seleccionar fotografía"),SOLICITUD_SELECCIONAR_FOTOGRAFIA);
        }
    }

    public void hacerFoto(View v) {

            String mediaStorageDir =
                    Environment.getExternalStoragePublicDirectory(
                            Environment.DIRECTORY_PICTURES).getPath();

            String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss",
                    Locale.ENGLISH).format(new Date());
            dest=new java.io.File(mediaStorageDir +
                    java.io.File.separator + "/" + "photos_share" + "/" + "IMG_" +imagencalidad+ "_" + timeStamp + ".jpg");
            nombreimagen="IMG_" +imagencalidad+ "_" + timeStamp + ".jpg";
            uriFichero = Uri.fromFile(dest);
            uriFicheroG = Uri.fromFile(dest);

        Log.e(tag,"SOLICITUD_HACER_FOTOGRAFIA uri: "+uriFichero);

            Intent cameraIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
            cameraIntent.putExtra(MediaStore.EXTRA_OUTPUT, uriFichero);

            startActivityForResult(cameraIntent, SOLICITUD_HACER_FOTOGRAFIA);
    }
    public boolean saveImageToInternalStorage(Bitmap image) {

        try {
            //Sino existe la ruta para guardar la creo
            java.io.File folder = new java.io.File(PATH, nombreimagen);

            if (folder.createNewFile()) {
                folder.createNewFile();
            }
            //Rotamos antes de guardar para poder subir al drive
            Bitmap bitmap = rotateImageIfRequired(image,uriFichero);
            uriFichero = Uri.fromFile(dest);
            Log.e(tag,"saveImageToInternalStorage uri: "+uriFichero);
            FileOutputStream out = new FileOutputStream(dest);
            bitmap.compress(Bitmap.CompressFormat.PNG, 90, out); //100 es cualidad maxima 0 calidad minima de compresion
            out.flush();
            out.close();
            bitmap=null;
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    @Override
    protected void onActivityResult(final int requestCode,
                                    final int resultCode, final Intent data) {
        switch (requestCode) {

            case SOLICITUD_HACER_FOTOGRAFIA:
                if (resultCode == Activity.RESULT_OK) {
                    L_layout.setVisibility(View.GONE);
                    R_layout.setVisibility(View.VISIBLE);
                    new ProcesarNuevaFoto_A().execute();
                }
                break;
            case SOLICITUD_SELECCIONAR_FOTOGRAFIA:
                if (resultCode == Activity.RESULT_OK) {
                    Uri ficheroSeleccionado = data.getData();
                    String[] proyeccion = { MediaStore.Images.Media.DATA };
                    Cursor cursor = managedQuery(ficheroSeleccionado, proyeccion,
                            null, null, null);
                    int column_index =
                            cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
                    cursor.moveToFirst();
                    uriFicheroG = Uri.fromFile(new java.io.File(cursor.getString(column_index)));
                    Log.e(tag,"SOLICITUD_SELECCIONAR_FOTOGRAFIA uri: "+uriFicheroG);

                    L_layout.setVisibility(View.GONE);
                    R_layout.setVisibility(View.VISIBLE);
                    new ProcesarNuevaFoto_A().execute();
                }
                break;

        }
    }

    private static Bitmap rotateImageIfRequired(Bitmap img, Uri selectedImage) throws IOException {

        ExifInterface ei = new ExifInterface(selectedImage.getPath());
        int orientation = ei.getAttributeInt(ExifInterface.TAG_ORIENTATION, ExifInterface.ORIENTATION_NORMAL);
        Log.e(tag,"Orientacion: "+orientation);


        switch (orientation) {
            case ExifInterface.ORIENTATION_ROTATE_90: //case 6
                Log.e(tag,"Entra Orientacion 90: "+orientation);
                return rotateImage(img, 90);
            case ExifInterface.ORIENTATION_ROTATE_180: //case 3
                Log.e(tag,"Entra Orientacion 180: "+orientation);
                return rotateImage(img, 180);
            case ExifInterface.ORIENTATION_ROTATE_270: //case 8
                Log.e(tag,"Entra Orientacion 270: "+orientation);
                return rotateImage(img, -90);
            case 1: //case 1 base
                return img;
            default:
                return img;
        }
    }

    private static Bitmap rotateImage(Bitmap img, int degree) {
        Matrix matrix = new Matrix();
        matrix.postRotate(degree);
        Bitmap rotatedImg = Bitmap.createBitmap(img, 0, 0, img.getWidth(), img.getHeight(), matrix, true);
        img.recycle();
        return rotatedImg;
    }

    //Reajusta el bitmap en funcion del maximo indicado
    public static Bitmap getResizedBitmapmaxsize(Bitmap bm, int newWidth, int newHeight) {
            int maxHeight = newWidth;
            int maxWidth = newHeight;
            float scale = Math.min(((float) maxHeight / bm.getWidth()), ((float) maxWidth / bm.getHeight()));

            Matrix matrix = new Matrix();
            matrix.postScale(scale, scale);
            Bitmap resizedBitmap = Bitmap.createBitmap(bm, 0, 0, bm.getWidth(), bm.getHeight(), matrix, true);
            //bm.recycle();
            return resizedBitmap;

    }

    @Override
    public void onBackPressed()
    {
        limpiarmemoria();
        finish();
    }

    private void limpiarmemoria(){
        //Eliminamos la imagen realizada
        if(nombreimagen!=null) {
            java.io.File folder = new java.io.File(PATH, nombreimagen);
            if (folder.delete()) {
                folder.delete();
            }
        }
        if (fotoportada!=null) {
            fotoportada.recycle();
            fotoportada=null;
        }
        if(miniatura!=null){
            ivDisplayH=null;
            photo=null;
            miniatura.recycle();
            miniatura=null;
        }
        if(temporal!=null){
            temporal.recycle();
            temporal=null;
        }
        if(bitmapGrises!=null){
            bitmapGrises.recycle();
            bitmapGrises=null;
        }
        if(bitmapSepia!=null){
            bitmapSepia.recycle();
            bitmapSepia=null;
        }
        if(bitmapMarco!=null){
            bitmapMarco.recycle();
            bitmapMarco=null;
        }
        if(bitmapActual!=null){
            bitmapActual.recycle();
            bitmapActual=null;
        }

    }

    // Comentarios sincronizar con PHP mediante Json
    private String convertStreamToString(InputStream is) {

        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
        StringBuilder sb = new StringBuilder();

        String line = null;
        try {
            while ((line = reader.readLine()) != null) {
                sb.append(line + "\n");
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                is.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return sb.toString();
    }

    //Código del Web Service
    public class SincronizarNuevaFoto extends AsyncTask<Integer, Integer, Integer> {
        protected void onPreExecute() {
            mostrarCarga(Nueva_photo.this,"Subiendo imagen...");
            comentarioimagen= comentario.getText().toString();
        }

        protected Integer doInBackground(Integer...args0) {
            //Guardar imagen saveImageToInternalStorage
            //*************************
            try {
                uriFichero = Uri.fromFile(dest);
                FileOutputStream out = new FileOutputStream(dest);
                bitmapActual.compress(Bitmap.CompressFormat.PNG, 100, out); //100 es cualidad maxima 0 calidad minima de compresion
                out.flush();
                out.close();

            } catch (Exception e) {
                e.printStackTrace();
                return 3; //Fallo al subir imagen
            }
            // subir imagen drive
            File ficheroSubido=null;
            try {
                java.io.File ficheroJava = new java.io.File(uriFichero.getPath());
                FileContent contenido = new FileContent("image/jpeg",ficheroJava);
                File ficheroDrive = new File();
                ficheroDrive.setTitle(ficheroJava.getName());
                ficheroDrive.setMimeType("image/jpeg");
                ficheroDrive.setParents(Arrays.asList(
                        new ParentReference().setId(idCarpeta)));
                ficheroSubido = servicio.files().insert(ficheroDrive,contenido).execute();

                if (ficheroSubido != null) {

                }else{
                    return 3; //Fallo al subir imagen
                }

            } catch (UserRecoverableAuthIOException e) {
                ocultarCarga(Nueva_photo.this);
                startActivityForResult(e.getIntent(), SOLICITUD_AUTORIZACION);
            } catch (IOException e) {
                mostrarMensaje(Nueva_photo.this, "Error;"+e.getMessage());
                ocultarCarga(Nueva_photo.this);
                e.printStackTrace();
            }
            if (ficheroSubido != null) {
                //Subir comentarios php
                try {
                    HttpClient client = new DefaultHttpClient();
                    org.apache.http.HttpResponse response;
                    HttpPost post = new HttpPost("http://victorserranobargues.esy.es/Upv/views/nuevafoto.php");
                    JSONObject jsonObj = new JSONObject();

                    JSONObject jsonAdd = new JSONObject();

                    jsonAdd.put("filename", nombreimagen);
                    jsonAdd.put("comentario", comentarioimagen);

                    jsonObj.put("Imagenes", jsonAdd);

                    Log.e("Json ", jsonObj.toString());
                    StringEntity se = new StringEntity(jsonObj.toString(), "UTF-8");
                    se.setContentEncoding(new BasicHeader(HTTP.CONTENT_TYPE, "application/json"));
                    post.setHeader("Accept-Language", "en-US");
                    post.setEntity(se);

                    response = client.execute(post);
                    if (response != null) {
                        InputStream in = response.getEntity().getContent();

                        String a = convertStreamToString(in);
                        Log.e("Retorno del PHP", a);
                        return 1; //Subida correctamente con comentario
                    } else {
                        return 2; //Subida correctamente error comentario
                    }
                } catch (Exception e) {
                    Log.d("error", e.toString());
                }
            }
            return 3; //Fallo al subir imagen

        }

        protected void onPostExecute(Integer valor) {
            //dialog.dismiss();
            if (valor==1) {
                mostrarMensaje(Nueva_photo.this, "¡Foto subida!");

            }else{
                mostrarMensaje(Nueva_photo.this, "¡Error al subir la imagen! "+valor);
            }
            limpiarmemoria();
            finish();
        }
    }

    private class ProcesarNuevaFoto_A extends AsyncTask<Void, Void, Void>{
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = ProgressDialog.show(Nueva_photo.this, "Procesando Imagen...", "Espere por favor...", true);
            try {
                //Libero memoria de la imagen de entrada
                photo_novios=null;
                fotoportada.recycle();
                fotoportada=null;

                //Capturo imagen camara
                temporal = MediaStore.Images.Media.getBitmap(Nueva_photo.this.getContentResolver(), uriFicheroG);
                Log.e(tag,"ProcesarNuevaFotoA uri: "+uriFicheroG);

                if (temporal!=null) {
                    //Redimensiono
                    //Si es de la misma dimension peta
                    if (temporal.getWidth() > imagencalidad || temporal.getHeight() > imagencalidad) {
                        bitmapActual = getResizedBitmapmaxsize(temporal, imagencalidad, imagencalidad);
                    } else {
                        bitmapActual = temporal;
                    }
                }else{
                    Toast.makeText(Nueva_photo.this, "No se puede acceder a la imagen seleccionada!", Toast.LENGTH_LONG).show();
                    Toast.makeText(Nueva_photo.this, "Seleccione otra por favor!", Toast.LENGTH_LONG).show();
                    limpiarmemoria();
                    finish();
                }

                //Liberar memoria
                temporal.recycle();
                temporal=null;

                //*****************
            } catch (IOException e) {
                e.printStackTrace();
            }catch (Throwable ex) {
                ex.printStackTrace();
                if (ex instanceof OutOfMemoryError) {
                    Toast.makeText(Nueva_photo.this, "Excedio la memoria, vuelva a intentarlo", Toast.LENGTH_LONG).show();
                    limpiarmemoria();
                    finish();
                }
            }
            //********************************************
        }
        @Override
        protected Void doInBackground(Void... params)
        {
            //Aquí ejecutamos nuestras tareas costosas
            try {
                java.io.File folder = new java.io.File(PATH, nombreimagen);
                java.io.File folder2 = new java.io.File(PATH);
                if (!folder2.exists()) {
                    folder2.mkdir();//If there is no folder it will be created.
                }
                if (folder.createNewFile()) {
                    folder.createNewFile();
                }
                Bitmap bitmap = rotateImageIfRequired(bitmapActual,uriFicheroG);
                FileOutputStream out = new FileOutputStream(PATH + nombreimagen);
                bitmap.compress(Bitmap.CompressFormat.PNG, 100, out); //100 es cualidad maxima 0 calidad minima de compresion
                out.flush();
                out.close();
                bitmap.recycle();
                bitmap=null;
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }
        @Override
        protected void onPostExecute(Void result) {
            pDialog.dismiss();
            //Cargo la imagen ya que al guardar modifica la orientacion
            onResetImagen();

        }
    }
}//Fin Nuevafoto