#include "com_vserrano_photos_share_Nueva_photo.h"
#include <android/log.h>
#include <android/bitmap.h>
#define LOG_TAG "libvserrano"
#define LOGI(...) __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)
#define LOGE(...) __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)
typedef struct
{
    uint8_t red;
    uint8_t green;
    uint8_t blue;
    uint8_t alpha;
} argb;
/*Conversion a grises por pixel*/
JNIEXPORT void JNICALL Java_com_vserrano_photos_1share_Nueva_1photo_convertirGrises
        (JNIEnv * env, jobject obj, jobject bitmapcolor,jobject bitmapgris)
{
    AndroidBitmapInfo infocolor;
    void* pixelscolor;
    AndroidBitmapInfo infogris;
    void* pixelsgris;
    int ret;
    int y;
    int x;
    LOGI("convertirGrises");
    if ((ret = AndroidBitmap_getInfo(env, bitmapcolor, &infocolor)) < 0) {
        LOGE("AndroidBitmap_getInfo() failed ! error=%d", ret);
        return;
    }
    if ((ret = AndroidBitmap_getInfo(env, bitmapgris, &infogris)) < 0) {
        LOGE("AndroidBitmap_getInfo() failed ! error=%d", ret);
        return;
    }
    LOGI("imagen color :: ancho %d;alto %d;avance %d;formato %d;flags %d", infocolor.
            width, infocolor.height, infocolor.stride,
         infocolor.format, infocolor.flags);
    if (infocolor.format != ANDROID_BITMAP_FORMAT_RGBA_8888) {
        LOGE("Bitmap no es formato RGBA_8888 !");
        return;
    }
    LOGI("imagen color :: ancho %d;alto %d;avance %d;formato %d;flags %d",
         infogris.width, infogris.height, infogris.stride,
         infogris.format, infogris.flags);
    if (infogris.format != ANDROID_BITMAP_FORMAT_RGBA_8888) {
        LOGE("Bitmap no es formato RGBA_8888 !");
        return;
    }
    if ((ret = AndroidBitmap_lockPixels(env, bitmapcolor, &pixelscolor))
        < 0) {
        LOGE("AndroidBitmap_lockPixels() failed ! error=%d", ret);
    }
    if ((ret = AndroidBitmap_lockPixels(env, bitmapgris, &pixelsgris))<0) {
        LOGE("AndroidBitmap_lockPixels() fallo ! error=%d", ret);
    }
// modificacion pixeles en el algoritmo de escala grises
    for (y=0;y<infocolor.height;y++) {
        argb * line = (argb *) pixelscolor;
        argb * grisline = (argb *) pixelsgris;
        for (x=0;x<infocolor.width;x++) {
            float output = (line[x].red + line[x].green + line[x].blue)/3;
            if (output > 255) output = 255;
            grisline[x].red = grisline[x].green = grisline[x].blue =
                    (uint8_t) output;
            grisline[x].alpha = line[x].alpha;
        }
        pixelscolor = (char *)pixelscolor + infocolor.stride;
        pixelsgris = (char *) pixelsgris + infogris.stride;
    }
    LOGI("unlocking pixels");
    AndroidBitmap_unlockPixels(env, bitmapcolor);
    AndroidBitmap_unlockPixels(env, bitmapgris);
}
/*Conversion a sepia por pixel*/
JNIEXPORT void JNICALL Java_com_vserrano_photos_1share_Nueva_1photo_convertirSepia
        (JNIEnv * env, jobject obj, jobject bitmapcolor,jobject bitmapgris)
{
    AndroidBitmapInfo infocolor;
    void* pixelscolor;
    AndroidBitmapInfo infogris;
    void* pixelsgris;
    int ret;
    int y;
    int x;
    LOGI("convertirSepia");
    if ((ret = AndroidBitmap_getInfo(env, bitmapcolor, &infocolor)) < 0) {
        LOGE("AndroidBitmap_getInfo() failed ! error=%d", ret);
        return;
    }
    if ((ret = AndroidBitmap_getInfo(env, bitmapgris, &infogris)) < 0) {
        LOGE("AndroidBitmap_getInfo() failed ! error=%d", ret);
        return;
    }
    LOGI("imagen color :: ancho %d;alto %d;avance %d;formato %d;flags %d", infocolor.
            width, infocolor.height, infocolor.stride,
         infocolor.format, infocolor.flags);
    if (infocolor.format != ANDROID_BITMAP_FORMAT_RGBA_8888) {
        LOGE("Bitmap no es formato RGBA_8888 !");
        return;
    }
    LOGI("imagen color :: ancho %d;alto %d;avance %d;formato %d;flags %d",
         infogris.width, infogris.height, infogris.stride,
         infogris.format, infogris.flags);
    if (infogris.format != ANDROID_BITMAP_FORMAT_RGBA_8888) {
        LOGE("Bitmap no es formato RGBA_8888 !");
        return;
    }
    if ((ret = AndroidBitmap_lockPixels(env, bitmapcolor, &pixelscolor))
        < 0) {
        LOGE("AndroidBitmap_lockPixels() failed ! error=%d", ret);
    }
    if ((ret = AndroidBitmap_lockPixels(env, bitmapgris, &pixelsgris))<0) {
        LOGE("AndroidBitmap_lockPixels() fallo ! error=%d", ret);
    }
// modificacion pixeles en el algoritmo de escala grises
    for (y=0;y<infocolor.height;y++) {
        argb * line = (argb *) pixelscolor;
        argb * grisline = (argb *) pixelsgris;
        for (x=0;x<infocolor.width;x++) {
            float outputRed = ((line[x].red * .393) + (line[x].green * .769) + (line[x].blue * .189));
            if (outputRed > 255) outputRed = 255;
            grisline[x].red = (uint8_t) outputRed;

            float outputGreen =((line[x].red * .349) + (line[x].green *.686) + (line[x].blue * .168));
            if (outputGreen > 255) outputGreen = 255;
            grisline[x].green = (uint8_t) outputGreen;

            float outputBlue =((line[x].red * .272) + (line[x].green *.534) + (line[x].blue * .131));
            if (outputBlue > 255) outputBlue = 255;
            grisline[x].blue=(uint8_t) outputBlue;

            grisline[x].alpha = line[x].alpha;
        }
        pixelscolor = (char *)pixelscolor + infocolor.stride;
        pixelsgris = (char *) pixelsgris + infogris.stride;
    }
    LOGI("unlocking pixels");
    AndroidBitmap_unlockPixels(env, bitmapcolor);
    AndroidBitmap_unlockPixels(env, bitmapgris);
}

/*Poner Marco por pixel*/
JNIEXPORT void JNICALL Java_com_vserrano_photos_1share_Nueva_1photo_convertirMarco
        (JNIEnv * env, jobject obj, jobject bitmapcolor,jobject bitmapgris)
{
    AndroidBitmapInfo infocolor;
    void* pixelscolor;
    AndroidBitmapInfo infogris;
    void* pixelsgris;
    int ret;
    int y;
    int x;
    LOGI("convertirGrises");
    if ((ret = AndroidBitmap_getInfo(env, bitmapcolor, &infocolor)) < 0) {
        LOGE("AndroidBitmap_getInfo() failed ! error=%d", ret);
        return;
    }
    if ((ret = AndroidBitmap_getInfo(env, bitmapgris, &infogris)) < 0) {
        LOGE("AndroidBitmap_getInfo() failed ! error=%d", ret);
        return;
    }
    LOGI("imagen color :: ancho %d;alto %d;avance %d;formato %d;flags %d", infocolor.
            width, infocolor.height, infocolor.stride,
         infocolor.format, infocolor.flags);
    if (infocolor.format != ANDROID_BITMAP_FORMAT_RGBA_8888) {
        LOGE("Bitmap no es formato RGBA_8888 !");
        return;
    }
    LOGI("imagen color :: ancho %d;alto %d;avance %d;formato %d;flags %d",
         infogris.width, infogris.height, infogris.stride,
         infogris.format, infogris.flags);
    if (infogris.format != ANDROID_BITMAP_FORMAT_RGBA_8888) {
        LOGE("Bitmap no es formato RGBA_8888 !");
        return;
    }
    if ((ret = AndroidBitmap_lockPixels(env, bitmapcolor, &pixelscolor))
        < 0) {
        LOGE("AndroidBitmap_lockPixels() failed ! error=%d", ret);
    }
    if ((ret = AndroidBitmap_lockPixels(env, bitmapgris, &pixelsgris))<0) {
        LOGE("AndroidBitmap_lockPixels() fallo ! error=%d", ret);
    }
// modificacion pixeles en el algoritmo de escala grises
    for (y=0;y<infocolor.height;y++) {
        argb * line = (argb *) pixelscolor;
        argb * marcoline = (argb *) pixelsgris;

            for (x = 0; x < infocolor.width; x++) {

                //if (x <= 10 || x >= infocolor.width - 10) {
                if((x<=10 || x>=(infocolor.width-10))||(y<=10 || y>=(infocolor.height-10))){
                    marcoline[x].red = 0;
                    marcoline[x].green = 0;
                    marcoline[x].blue = 0;
                    marcoline[x].alpha = line[x].alpha;
                }else{
                    marcoline[x].red = line[x].red;
                    marcoline[x].green = line[x].green;
                    marcoline[x].blue = line[x].blue;
                    marcoline[x].alpha = line[x].alpha;
                }

            }

        pixelscolor = (char *)pixelscolor + infocolor.stride;
        pixelsgris = (char *) pixelsgris + infogris.stride;
    }
    LOGI("unlocking pixels");
    AndroidBitmap_unlockPixels(env, bitmapcolor);
    AndroidBitmap_unlockPixels(env, bitmapgris);
}